/*
 * Metadata Extractor API
 *
 * This API extracts RDF triples from files
 *
 * The version of the OpenAPI document: 0.4.3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Net.Mime;
using Coscine.MetadataExtractor.Core.Client;
using Coscine.MetadataExtractor.Core.Model;

namespace Coscine.MetadataExtractor.Core.Api
{

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IDefaultApiSync : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// 
        /// </summary>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns></returns>
        void GetConfigWorker(int operationIndex = 0);

        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> GetConfigWorkerWithHttpInfo(int operationIndex = 0);
        /// <summary>
        /// 
        /// </summary>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ModelVersion</returns>
        ModelVersion GetVersionWorker(int operationIndex = 0);

        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of ModelVersion</returns>
        ApiResponse<ModelVersion> GetVersionWorkerWithHttpInfo(int operationIndex = 0);
        /// <summary>
        /// 
        /// </summary>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accept"></param>
        /// <param name="identifier">File Identifier (optional)</param>
        /// <param name="config">Object defining the utilized configuration (try \\\&quot;/defaultConfig\\\&quot; to get the structure) (optional)</param>
        /// <param name="creationDate">Creation Date (Time) (e.g. \\\&quot;2022-09-15T09:27:17.3550000+02:00\\\&quot;) (optional)</param>
        /// <param name="modificationDate">Modification Date (Time) (e.g. \\\&quot;2022-09-15T09:27:17.3550000+02:00\\\&quot;) (optional)</param>
        /// <param name="url">Download URL of file (optional)</param>
        /// <param name="file"> (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>List&lt;MetadataOutput&gt;</returns>
        List<MetadataOutput> PostMetadataExtractorWorker(string accept, string? identifier = default(string?), string? config = default(string?), string? creationDate = default(string?), string? modificationDate = default(string?), string? url = default(string?), System.IO.Stream? file = default(System.IO.Stream?), int operationIndex = 0);

        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accept"></param>
        /// <param name="identifier">File Identifier (optional)</param>
        /// <param name="config">Object defining the utilized configuration (try \\\&quot;/defaultConfig\\\&quot; to get the structure) (optional)</param>
        /// <param name="creationDate">Creation Date (Time) (e.g. \\\&quot;2022-09-15T09:27:17.3550000+02:00\\\&quot;) (optional)</param>
        /// <param name="modificationDate">Modification Date (Time) (e.g. \\\&quot;2022-09-15T09:27:17.3550000+02:00\\\&quot;) (optional)</param>
        /// <param name="url">Download URL of file (optional)</param>
        /// <param name="file"> (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of List&lt;MetadataOutput&gt;</returns>
        ApiResponse<List<MetadataOutput>> PostMetadataExtractorWorkerWithHttpInfo(string accept, string? identifier = default(string?), string? config = default(string?), string? creationDate = default(string?), string? modificationDate = default(string?), string? url = default(string?), System.IO.Stream? file = default(System.IO.Stream?), int operationIndex = 0);
        #endregion Synchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IDefaultApiAsync : IApiAccessor
    {
        #region Asynchronous Operations
        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task GetConfigWorkerAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> GetConfigWorkerWithHttpInfoAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ModelVersion</returns>
        System.Threading.Tasks.Task<ModelVersion> GetVersionWorkerAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (ModelVersion)</returns>
        System.Threading.Tasks.Task<ApiResponse<ModelVersion>> GetVersionWorkerWithHttpInfoAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accept"></param>
        /// <param name="identifier">File Identifier (optional)</param>
        /// <param name="config">Object defining the utilized configuration (try \\\&quot;/defaultConfig\\\&quot; to get the structure) (optional)</param>
        /// <param name="creationDate">Creation Date (Time) (e.g. \\\&quot;2022-09-15T09:27:17.3550000+02:00\\\&quot;) (optional)</param>
        /// <param name="modificationDate">Modification Date (Time) (e.g. \\\&quot;2022-09-15T09:27:17.3550000+02:00\\\&quot;) (optional)</param>
        /// <param name="url">Download URL of file (optional)</param>
        /// <param name="file"> (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of List&lt;MetadataOutput&gt;</returns>
        System.Threading.Tasks.Task<List<MetadataOutput>> PostMetadataExtractorWorkerAsync(string accept, string? identifier = default(string?), string? config = default(string?), string? creationDate = default(string?), string? modificationDate = default(string?), string? url = default(string?), System.IO.Stream? file = default(System.IO.Stream?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// 
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accept"></param>
        /// <param name="identifier">File Identifier (optional)</param>
        /// <param name="config">Object defining the utilized configuration (try \\\&quot;/defaultConfig\\\&quot; to get the structure) (optional)</param>
        /// <param name="creationDate">Creation Date (Time) (e.g. \\\&quot;2022-09-15T09:27:17.3550000+02:00\\\&quot;) (optional)</param>
        /// <param name="modificationDate">Modification Date (Time) (e.g. \\\&quot;2022-09-15T09:27:17.3550000+02:00\\\&quot;) (optional)</param>
        /// <param name="url">Download URL of file (optional)</param>
        /// <param name="file"> (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (List&lt;MetadataOutput&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<MetadataOutput>>> PostMetadataExtractorWorkerWithHttpInfoAsync(string accept, string? identifier = default(string?), string? config = default(string?), string? creationDate = default(string?), string? modificationDate = default(string?), string? url = default(string?), System.IO.Stream? file = default(System.IO.Stream?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IDefaultApi : IDefaultApiSync, IDefaultApiAsync
    {

    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class DefaultApi : IDefaultApi
    {
        private Coscine.MetadataExtractor.Core.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="DefaultApi"/> class.
        /// </summary>
        /// <returns></returns>
        public DefaultApi() : this((string)null)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DefaultApi"/> class.
        /// </summary>
        /// <returns></returns>
        public DefaultApi(string basePath)
        {
            this.Configuration = Coscine.MetadataExtractor.Core.Client.Configuration.MergeConfigurations(
                Coscine.MetadataExtractor.Core.Client.GlobalConfiguration.Instance,
                new Coscine.MetadataExtractor.Core.Client.Configuration { BasePath = basePath }
            );
            this.Client = new Coscine.MetadataExtractor.Core.Client.ApiClient(this.Configuration.BasePath);
            this.AsynchronousClient = new Coscine.MetadataExtractor.Core.Client.ApiClient(this.Configuration.BasePath);
            this.ExceptionFactory = Coscine.MetadataExtractor.Core.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DefaultApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public DefaultApi(Coscine.MetadataExtractor.Core.Client.Configuration configuration)
        {
            if (configuration == null) throw new ArgumentNullException("configuration");

            this.Configuration = Coscine.MetadataExtractor.Core.Client.Configuration.MergeConfigurations(
                Coscine.MetadataExtractor.Core.Client.GlobalConfiguration.Instance,
                configuration
            );
            this.Client = new Coscine.MetadataExtractor.Core.Client.ApiClient(this.Configuration.BasePath);
            this.AsynchronousClient = new Coscine.MetadataExtractor.Core.Client.ApiClient(this.Configuration.BasePath);
            ExceptionFactory = Coscine.MetadataExtractor.Core.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DefaultApi"/> class
        /// using a Configuration object and client instance.
        /// </summary>
        /// <param name="client">The client interface for synchronous API access.</param>
        /// <param name="asyncClient">The client interface for asynchronous API access.</param>
        /// <param name="configuration">The configuration object.</param>
        public DefaultApi(Coscine.MetadataExtractor.Core.Client.ISynchronousClient client, Coscine.MetadataExtractor.Core.Client.IAsynchronousClient asyncClient, Coscine.MetadataExtractor.Core.Client.IReadableConfiguration configuration)
        {
            if (client == null) throw new ArgumentNullException("client");
            if (asyncClient == null) throw new ArgumentNullException("asyncClient");
            if (configuration == null) throw new ArgumentNullException("configuration");

            this.Client = client;
            this.AsynchronousClient = asyncClient;
            this.Configuration = configuration;
            this.ExceptionFactory = Coscine.MetadataExtractor.Core.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// The client for accessing this underlying API asynchronously.
        /// </summary>
        public Coscine.MetadataExtractor.Core.Client.IAsynchronousClient AsynchronousClient { get; set; }

        /// <summary>
        /// The client for accessing this underlying API synchronously.
        /// </summary>
        public Coscine.MetadataExtractor.Core.Client.ISynchronousClient Client { get; set; }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public string GetBasePath()
        {
            return this.Configuration.BasePath;
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Coscine.MetadataExtractor.Core.Client.IReadableConfiguration Configuration { get; set; }

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public Coscine.MetadataExtractor.Core.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        ///  
        /// </summary>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns></returns>
        public void GetConfigWorker(int operationIndex = 0)
        {
            GetConfigWorkerWithHttpInfo();
        }

        /// <summary>
        ///  
        /// </summary>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public Coscine.MetadataExtractor.Core.Client.ApiResponse<Object> GetConfigWorkerWithHttpInfo(int operationIndex = 0)
        {
            Coscine.MetadataExtractor.Core.Client.RequestOptions localVarRequestOptions = new Coscine.MetadataExtractor.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
            };

            var localVarContentType = Coscine.MetadataExtractor.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.MetadataExtractor.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }


            localVarRequestOptions.Operation = "DefaultApi.GetConfigWorker";
            localVarRequestOptions.OperationIndex = operationIndex;


            // make the HTTP request
            var localVarResponse = this.Client.Get<Object>("/defaultConfig", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetConfigWorker", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        ///  
        /// </summary>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task GetConfigWorkerAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            await GetConfigWorkerWithHttpInfoAsync(operationIndex, cancellationToken).ConfigureAwait(false);
        }

        /// <summary>
        ///  
        /// </summary>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<Coscine.MetadataExtractor.Core.Client.ApiResponse<Object>> GetConfigWorkerWithHttpInfoAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {

            Coscine.MetadataExtractor.Core.Client.RequestOptions localVarRequestOptions = new Coscine.MetadataExtractor.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
            };

            var localVarContentType = Coscine.MetadataExtractor.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.MetadataExtractor.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }


            localVarRequestOptions.Operation = "DefaultApi.GetConfigWorker";
            localVarRequestOptions.OperationIndex = operationIndex;


            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<Object>("/defaultConfig", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetConfigWorker", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        ///  
        /// </summary>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ModelVersion</returns>
        public ModelVersion GetVersionWorker(int operationIndex = 0)
        {
            Coscine.MetadataExtractor.Core.Client.ApiResponse<ModelVersion> localVarResponse = GetVersionWorkerWithHttpInfo();
            return localVarResponse.Data;
        }

        /// <summary>
        ///  
        /// </summary>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of ModelVersion</returns>
        public Coscine.MetadataExtractor.Core.Client.ApiResponse<ModelVersion> GetVersionWorkerWithHttpInfo(int operationIndex = 0)
        {
            Coscine.MetadataExtractor.Core.Client.RequestOptions localVarRequestOptions = new Coscine.MetadataExtractor.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Coscine.MetadataExtractor.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.MetadataExtractor.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }


            localVarRequestOptions.Operation = "DefaultApi.GetVersionWorker";
            localVarRequestOptions.OperationIndex = operationIndex;


            // make the HTTP request
            var localVarResponse = this.Client.Get<ModelVersion>("/version", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetVersionWorker", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        ///  
        /// </summary>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ModelVersion</returns>
        public async System.Threading.Tasks.Task<ModelVersion> GetVersionWorkerAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            Coscine.MetadataExtractor.Core.Client.ApiResponse<ModelVersion> localVarResponse = await GetVersionWorkerWithHttpInfoAsync(operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        ///  
        /// </summary>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (ModelVersion)</returns>
        public async System.Threading.Tasks.Task<Coscine.MetadataExtractor.Core.Client.ApiResponse<ModelVersion>> GetVersionWorkerWithHttpInfoAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {

            Coscine.MetadataExtractor.Core.Client.RequestOptions localVarRequestOptions = new Coscine.MetadataExtractor.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Coscine.MetadataExtractor.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.MetadataExtractor.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }


            localVarRequestOptions.Operation = "DefaultApi.GetVersionWorker";
            localVarRequestOptions.OperationIndex = operationIndex;


            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<ModelVersion>("/version", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetVersionWorker", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        ///  
        /// </summary>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accept"></param>
        /// <param name="identifier">File Identifier (optional)</param>
        /// <param name="config">Object defining the utilized configuration (try \\\&quot;/defaultConfig\\\&quot; to get the structure) (optional)</param>
        /// <param name="creationDate">Creation Date (Time) (e.g. \\\&quot;2022-09-15T09:27:17.3550000+02:00\\\&quot;) (optional)</param>
        /// <param name="modificationDate">Modification Date (Time) (e.g. \\\&quot;2022-09-15T09:27:17.3550000+02:00\\\&quot;) (optional)</param>
        /// <param name="url">Download URL of file (optional)</param>
        /// <param name="file"> (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>List&lt;MetadataOutput&gt;</returns>
        public List<MetadataOutput> PostMetadataExtractorWorker(string accept, string? identifier = default(string?), string? config = default(string?), string? creationDate = default(string?), string? modificationDate = default(string?), string? url = default(string?), System.IO.Stream? file = default(System.IO.Stream?), int operationIndex = 0)
        {
            Coscine.MetadataExtractor.Core.Client.ApiResponse<List<MetadataOutput>> localVarResponse = PostMetadataExtractorWorkerWithHttpInfo(accept, identifier, config, creationDate, modificationDate, url, file);
            return localVarResponse.Data;
        }

        /// <summary>
        ///  
        /// </summary>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accept"></param>
        /// <param name="identifier">File Identifier (optional)</param>
        /// <param name="config">Object defining the utilized configuration (try \\\&quot;/defaultConfig\\\&quot; to get the structure) (optional)</param>
        /// <param name="creationDate">Creation Date (Time) (e.g. \\\&quot;2022-09-15T09:27:17.3550000+02:00\\\&quot;) (optional)</param>
        /// <param name="modificationDate">Modification Date (Time) (e.g. \\\&quot;2022-09-15T09:27:17.3550000+02:00\\\&quot;) (optional)</param>
        /// <param name="url">Download URL of file (optional)</param>
        /// <param name="file"> (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of List&lt;MetadataOutput&gt;</returns>
        public Coscine.MetadataExtractor.Core.Client.ApiResponse<List<MetadataOutput>> PostMetadataExtractorWorkerWithHttpInfo(string accept, string? identifier = default(string?), string? config = default(string?), string? creationDate = default(string?), string? modificationDate = default(string?), string? url = default(string?), System.IO.Stream? file = default(System.IO.Stream?), int operationIndex = 0)
        {
            // verify the required parameter 'accept' is set
            if (accept == null)
            {
                throw new Coscine.MetadataExtractor.Core.Client.ApiException(400, "Missing required parameter 'accept' when calling DefaultApi->PostMetadataExtractorWorker");
            }

            Coscine.MetadataExtractor.Core.Client.RequestOptions localVarRequestOptions = new Coscine.MetadataExtractor.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
                "multipart/form-data"
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Coscine.MetadataExtractor.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.MetadataExtractor.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.HeaderParameters.Add("accept", Coscine.MetadataExtractor.Core.Client.ClientUtils.ParameterToString(accept)); // header parameter
            if (identifier != null)
            {
                localVarRequestOptions.FormParameters.Add("identifier", Coscine.MetadataExtractor.Core.Client.ClientUtils.ParameterToString(identifier)); // form parameter
            }
            if (config != null)
            {
                localVarRequestOptions.FormParameters.Add("config", Coscine.MetadataExtractor.Core.Client.ClientUtils.ParameterToString(config)); // form parameter
            }
            if (creationDate != null)
            {
                localVarRequestOptions.FormParameters.Add("creation_date", Coscine.MetadataExtractor.Core.Client.ClientUtils.ParameterToString(creationDate)); // form parameter
            }
            if (modificationDate != null)
            {
                localVarRequestOptions.FormParameters.Add("modification_date", Coscine.MetadataExtractor.Core.Client.ClientUtils.ParameterToString(modificationDate)); // form parameter
            }
            if (url != null)
            {
                localVarRequestOptions.FormParameters.Add("url", Coscine.MetadataExtractor.Core.Client.ClientUtils.ParameterToString(url)); // form parameter
            }
            if (file != null)
            {
                localVarRequestOptions.FileParameters.Add("file", file);
            }

            localVarRequestOptions.Operation = "DefaultApi.PostMetadataExtractorWorker";
            localVarRequestOptions.OperationIndex = operationIndex;


            // make the HTTP request
            var localVarResponse = this.Client.Post<List<MetadataOutput>>("/", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("PostMetadataExtractorWorker", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        ///  
        /// </summary>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accept"></param>
        /// <param name="identifier">File Identifier (optional)</param>
        /// <param name="config">Object defining the utilized configuration (try \\\&quot;/defaultConfig\\\&quot; to get the structure) (optional)</param>
        /// <param name="creationDate">Creation Date (Time) (e.g. \\\&quot;2022-09-15T09:27:17.3550000+02:00\\\&quot;) (optional)</param>
        /// <param name="modificationDate">Modification Date (Time) (e.g. \\\&quot;2022-09-15T09:27:17.3550000+02:00\\\&quot;) (optional)</param>
        /// <param name="url">Download URL of file (optional)</param>
        /// <param name="file"> (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of List&lt;MetadataOutput&gt;</returns>
        public async System.Threading.Tasks.Task<List<MetadataOutput>> PostMetadataExtractorWorkerAsync(string accept, string? identifier = default(string?), string? config = default(string?), string? creationDate = default(string?), string? modificationDate = default(string?), string? url = default(string?), System.IO.Stream? file = default(System.IO.Stream?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            Coscine.MetadataExtractor.Core.Client.ApiResponse<List<MetadataOutput>> localVarResponse = await PostMetadataExtractorWorkerWithHttpInfoAsync(accept, identifier, config, creationDate, modificationDate, url, file, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        ///  
        /// </summary>
        /// <exception cref="Coscine.MetadataExtractor.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accept"></param>
        /// <param name="identifier">File Identifier (optional)</param>
        /// <param name="config">Object defining the utilized configuration (try \\\&quot;/defaultConfig\\\&quot; to get the structure) (optional)</param>
        /// <param name="creationDate">Creation Date (Time) (e.g. \\\&quot;2022-09-15T09:27:17.3550000+02:00\\\&quot;) (optional)</param>
        /// <param name="modificationDate">Modification Date (Time) (e.g. \\\&quot;2022-09-15T09:27:17.3550000+02:00\\\&quot;) (optional)</param>
        /// <param name="url">Download URL of file (optional)</param>
        /// <param name="file"> (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (List&lt;MetadataOutput&gt;)</returns>
        public async System.Threading.Tasks.Task<Coscine.MetadataExtractor.Core.Client.ApiResponse<List<MetadataOutput>>> PostMetadataExtractorWorkerWithHttpInfoAsync(string accept, string? identifier = default(string?), string? config = default(string?), string? creationDate = default(string?), string? modificationDate = default(string?), string? url = default(string?), System.IO.Stream? file = default(System.IO.Stream?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            // verify the required parameter 'accept' is set
            if (accept == null)
            {
                throw new Coscine.MetadataExtractor.Core.Client.ApiException(400, "Missing required parameter 'accept' when calling DefaultApi->PostMetadataExtractorWorker");
            }


            Coscine.MetadataExtractor.Core.Client.RequestOptions localVarRequestOptions = new Coscine.MetadataExtractor.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
                "multipart/form-data"
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Coscine.MetadataExtractor.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.MetadataExtractor.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.HeaderParameters.Add("accept", Coscine.MetadataExtractor.Core.Client.ClientUtils.ParameterToString(accept)); // header parameter
            if (identifier != null)
            {
                localVarRequestOptions.FormParameters.Add("identifier", Coscine.MetadataExtractor.Core.Client.ClientUtils.ParameterToString(identifier)); // form parameter
            }
            if (config != null)
            {
                localVarRequestOptions.FormParameters.Add("config", Coscine.MetadataExtractor.Core.Client.ClientUtils.ParameterToString(config)); // form parameter
            }
            if (creationDate != null)
            {
                localVarRequestOptions.FormParameters.Add("creation_date", Coscine.MetadataExtractor.Core.Client.ClientUtils.ParameterToString(creationDate)); // form parameter
            }
            if (modificationDate != null)
            {
                localVarRequestOptions.FormParameters.Add("modification_date", Coscine.MetadataExtractor.Core.Client.ClientUtils.ParameterToString(modificationDate)); // form parameter
            }
            if (url != null)
            {
                localVarRequestOptions.FormParameters.Add("url", Coscine.MetadataExtractor.Core.Client.ClientUtils.ParameterToString(url)); // form parameter
            }
            if (file != null)
            {
                localVarRequestOptions.FileParameters.Add("file", file);
            }

            localVarRequestOptions.Operation = "DefaultApi.PostMetadataExtractorWorker";
            localVarRequestOptions.OperationIndex = operationIndex;


            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.PostAsync<List<MetadataOutput>>("/", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("PostMetadataExtractorWorker", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

    }
}
